{$O-}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, PaxInterpreter, PaxCompiler, PaxRegister, PaxBasicLanguage,
  PaxRunner;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    ClickMe: TButton;
    PaxCompiler1: TPaxCompiler;
    PaxBasicLanguage1: TPaxBasicLanguage;
    PaxInterpreter1: TPaxInterpreter;
    procedure Button1Click(Sender: TObject);
    procedure ClickMeClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    P_SetHandler: Pointer;
    P_RestoreHandler: Pointer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  H_TButton, H_TForm1: Integer;

type
  TProcP = procedure;

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
begin
  if PaxInterpreter1.DataSize > 0 then
  begin
    ShowMessage('Script is already compiled.');
    Exit;
  end;

  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxBasicLanguage1);
  PaxCompiler1.AddModule('1', 'Basic');
  PaxCompiler1.AddCode('1', Memo1.Lines.Text);
  PaxCompiler1.RegisterVariable(0, 'ClickMe', H_TButton, @ClickMe);
  PaxCompiler1.RegisterVariable(0, 'Form1', H_TForm1, @Form1);

  if PaxCompiler1.Compile(PaxInterpreter1) then
  begin
    P_SetHandler := PaxInterpreter1.GetAddress('SetHandler');
    P_RestoreHandler := PaxInterpreter1.GetAddress('RestoreHandler');

    PaxInterpreter1.Run;
  end
  else
    for I:=0 to PaxCompiler1.ErrorCount - 1 do
      ShowMessage(PaxCompiler1.ErrorMessage[I]);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  TProcP(P_SetHandler);

  ShowMessage('ClickMe contains script-defined event handler now.');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  TProcP(P_RestoreHandler);

  ShowMessage('Host-defined handler is restored.');
end;

procedure TForm1.ClickMeClick(Sender: TObject);
begin
  ShowMessage('Host-defined event handler. Sender: ' + Sender.ClassName);
end;

initialization
  H_TButton := RegisterClassType(0, TButton);
  H_TForm1 := RegisterClassType(0, TForm1);
  RegisterHeader(0, 'procedure ShowMessage(const Msg: string);', @ShowMessage);

end.
