unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PaxInterpreter, PaxCompiler, StdCtrls, PAXCOMP_STDLIB, PaxBasicLanguage,
  PaxRunner;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    PaxCompiler1: TPaxCompiler;
    Memo2: TMemo;
    PaxBasicLanguage1: TPaxBasicLanguage;
    PaxInterpreter1: TPaxInterpreter;
    procedure Button1Click(Sender: TObject);
    procedure PaxInterpreter1PrintEvent(Sender: TPaxRunner; const Text: string);
    procedure PaxInterpreter1Exception(Sender: TPaxRunner; E: Exception;
      const ModuleName: string; SourceLineNumber: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  IMPORT_SysUtils;

procedure TForm1.Button1Click(Sender: TObject);
begin
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxBasicLanguage1);
  PaxCompiler1.AddModule('main', 'Basic');
  PaxCompiler1.AddCode('main', Memo1.Lines.Text);
  if PaxCompiler1.Compile(PaxInterpreter1) then
  begin
    PaxInterpreter1.Run;
  end
  else
    ShowMessage(PaxCompiler1.ErrorMessage[0]);
end;

procedure TForm1.PaxInterpreter1Exception(Sender: TPaxRunner; E: Exception;
  const ModuleName: string; SourceLineNumber: Integer);
begin
  Form1.Memo2.Text := Form1.Memo2.Text + #13#10 +
      'Exception (' + E.Message +
      ') raised at line ' + IntToStr(SourceLineNumber) + ':' +
      PaxCompiler1.Modules[ModuleName][SourceLineNumber] + #13#10;
end;

procedure TForm1.PaxInterpreter1PrintEvent(Sender: TPaxRunner;
  const Text: string);
begin
  Form1.Memo2.Text := Form1.Memo2.Text + Text;
end;

initialization

Register_SysUtils;

end.
