unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PaxInterpreter, PaxCompiler, PaxRegister, StdCtrls, PaxBasicLanguage,
  PaxRunner;

type
  TForm1 = class(TForm)
    Button1: TButton;
    PaxCompiler1: TPaxCompiler;
    PaxBasicLanguage1: TPaxBasicLanguage;
    PaxInterpreter1: TPaxInterpreter;
    procedure Button1Click(Sender: TObject);
    function PaxCompiler1UsedUnit(Sender: TPaxCompiler;
      const UnitName: String; var SourceCode: String): Boolean;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxBasicLanguage1);
  PaxCompiler1.AddModule('main', 'Basic');
  PaxCompiler1.AddCode('main', 'Imports SomeUnit');
  PaxCompiler1.AddCode('main', 'P()');
  if PaxCompiler1.Compile(PaxInterpreter1) then
  begin
    PaxInterpreter1.Run;
  end
  else
    ShowMessage(PaxCompiler1.ErrorMessage[0]);
end;

function TForm1.PaxCompiler1UsedUnit(Sender: TPaxCompiler;
  const UnitName: String; var SourceCode: String): Boolean;
begin
  if UnitName = 'SomeUnit' then
  begin
    result := true;
    SourceCode :=

    'Module SomeUnit' + #13#10 +
    '  Public Sub P' + #13#10 +
    '    ShowMessage("Hello")' + #13#10 +
    '  End Sub' + #13#10 +
    'End Module' + #13#10;

  end
  else
    result := false; // default processing
end;

initialization
  RegisterHeader(0, 'procedure ShowMessage(const Msg: string);', @ShowMessage);
end.
