{$APPTYPE CONSOLE}
{$O-}
program Project1;
uses
  Classes,
  PaxCompiler, PaxInterpreter, PaxRegister;

type
  IMyInterface = interface
    ['{D13115CA-4D57-4242-A54B-3684870CC7B3}']
    function Add(X, Y: Integer): Integer;
  end;

procedure PassToHost(X: IMyInterface; P1, P2: Integer);
begin
  writeln(X.Add(P1, P2));
end;

var
  PaxCompiler1: TPaxCompiler;
  PaxInterpreter1: TPaxInterpreter;
  PaxPascalLanguage1: TPaxPascalLanguage;
  I: Integer;
begin
  I := RegisterInterfaceType(0, 'IMyInterface', IMyInterface);
  RegisterHeader(I,
    'function Add(X, Y: Integer): Integer;', nil, -1);

  RegisterHeader(0,
    'procedure PassToHost(X: IMyInterface; P1, P2: Integer);',
    @ PassToHost);

  PaxCompiler1 := TPaxCompiler.Create(nil);
  PaxInterpreter1 := TPaxInterpreter.Create(nil);
  PaxPascalLanguage1 := TPaxPascalLanguage.Create(nil);
  try
    PaxCompiler1.RegisterLanguage(PaxPascalLanguage1);
    PaxCompiler1.AddModule('1', 'Pascal');
    PaxCompiler1.AddCodeFromFile('1', 'script.txt');
    if PaxCompiler1.Compile(PaxInterpreter1) then
    begin
      PaxInterpreter1.Run;
    end
    else
    begin
      writeln(PaxCompiler1.ErrorMessage[0]);
      writeln(PaxCompiler1.ErrorLineNumber[0]);
      writeln(PaxCompiler1.ErrorLine[0]);
    end;

    for I:=0 to PaxCompiler1.WarningCount - 1 do
    begin
      writeln(PaxCompiler1.WarningMessage[I]);
      writeln(PaxCompiler1.WarningLineNumber[I]);
      writeln(PaxCompiler1.WarningLine[I]);
    end;

  finally
    PaxCompiler1.Free;
    PaxInterpreter1.Free;
    PaxPascalLanguage1.Free;
  end;
  writeln('Press any key...');
  Readln;
end.
