{$APPTYPE CONSOLE}
program Project1;
uses
  PaxCompiler, PaxInterpreter, PaxRegister;
type
  TMyHostClass = class
  public
    constructor Create; virtual; abstract;
    procedure P; virtual; abstract;
  end;
  TMyHostClassClass = class of TMyHostClass;

var
  PaxCompiler1: TPaxCompiler;
  PaxInterpreter1: TPaxInterpreter;
  PaxPascalLanguage1: TPaxPascalLanguage;
  I: Integer;

  C: TMyHostClassClass;
  X: TMyHostClass;
begin
  I := RegisterClassType(0, TMyHostClass);
  RegisterHeader(I,
    'constructor Create; virtual; abstract;',
       nil);
  RegisterHeader(I,
    'procedure P; virtual; abstract;',
       nil);

  PaxCompiler1 := TPaxCompiler.Create(nil);
  PaxInterpreter1 := TPaxInterpreter.Create(nil);
  PaxPascalLanguage1 := TPaxPascalLanguage.Create(nil);
  try
    PaxCompiler1.RegisterLanguage(PaxPascalLanguage1);
    PaxCompiler1.AddModule('1', 'Pascal');
    PaxCompiler1.AddCodeFromFile('1', 'script.txt');
    if PaxCompiler1.Compile(PaxInterpreter1) then
    begin
      PaxInterpreter1.RunInitialization;

      C := TMyHostClassClass(PaxInterpreter1.GetAddress('TMyScriptClass')^);
      X := C.Create;
      X.P;
      X.Free;
    end
    else
    begin
      writeln(PaxCompiler1.ErrorMessage[0]);
      writeln(PaxCompiler1.ErrorLineNumber[0]);
      writeln(PaxCompiler1.ErrorLine[0]);
    end;

    for I:=0 to PaxCompiler1.WarningCount - 1 do
    begin
      writeln(PaxCompiler1.WarningMessage[I]);
      writeln(PaxCompiler1.WarningLineNumber[I]);
      writeln(PaxCompiler1.WarningLine[I]);
    end;

  finally
    PaxCompiler1.Free;
    PaxInterpreter1.Free;
    PaxPascalLanguage1.Free;
  end;
  writeln('Press any key...');
  Readln;
end.
