{$APPTYPE CONSOLE}
{$O-}
program Project1;
uses
  TypInfo,
  Classes,
  SysUtils,
  PaxCompiler,
  PaxInterpreter,
  PaxRegister;

type
  TTest = class(TComponent)
  public
    procedure Save;
  end;

{ TTest }

procedure MyGetPropertyNames(aObject: TObject; aStringList: TStringList);
var
  count : integer;
  size : integer;
  list : PPropList;
  i : integer;
  ppi: PPropInfo;
begin
  aStringList.Clear;
  count := GetPropList(PTypeInfo(aObject.ClassInfo), tkProperties, nil, false);
  size  := count * SizeOf(Pointer);
  GetMem(list, size);
  try
    GetPropList(PTypeInfo(aObject.ClassInfo), tkProperties, list, false);
    for i := 0 to count - 1 do
      aStringList.Add(list^[i]^.Name);
  finally
    FreeMem(list, size);
  end;
end;

type
  TMyStringList = class(TStringList)
  published
    property Text;
  end;

procedure TTest.Save;
var
  list: TMyStringList;
begin
  list := TMyStringList.Create;
  try
    MyGetPropertyNames(self, list);   
    writeln('Property Count = ', list.Count);
    writeln('Properties are: ' + list.Text);
  finally
    list.free;
  end;
end;

var
  PaxInterpreter1: TPaxInterpreter;
  PaxCompiler1: TPaxCompiler;
  PaxPascalLanguage1: TPaxPascalLanguage;
  H: Integer;
begin
  H := RegisterClassType(0, TTest);
  RegisterHeader(H, 'procedure Save;', @TTest.Save);

  PaxCompiler1 := TPaxCompiler.Create(nil);
  PaxInterpreter1 := TPaxInterpreter.Create(nil);
  PaxPascalLanguage1 := TPaxPascalLanguage.Create(nil);
  try
    PaxCompiler1.RegisterLanguage(PaxPascalLanguage1);
    PaxCompiler1.AddModule('1', 'Pascal');
    PaxCompiler1.AddCodeFromFile('1', 'script.txt');
    if PaxCompiler1.Compile(PaxInterpreter1) then
    begin
      PaxInterpreter1.Run;
    end
    else
      writeln(PaxCompiler1.ErrorMessage[0]);
  finally
    PaxCompiler1.Free;
    PaxInterpreter1.Free;
    PaxPascalLanguage1.Free;
  end;
  writeln('Press any key...');
  Readln;
end.
