{$O-}
{$I PaxCompiler.def}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Variants,
  Dialogs, Buttons, ExtCtrls, StdCtrls, PaxCompiler, PAXCOMP_STDLIB, Menus,
  PAXCOMP_CONSTANTS,
  PaxRegister,
  PaxPE,
  PaxInterpreter, PaxBasicLanguage, PaxJavaScriptLanguage, PaxRunner;

const
  DllName = 'PaxCompilerRun.dll';
  RunScriptName = 'RunScript';
  ScriptDllMainName = 'ScriptDllMain';
type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButtonNew: TSpeedButton;
    Memo1: TMemo;
    SpeedButtonOpen: TSpeedButton;
    SpeedButtonSave: TSpeedButton;
    SpeedButtonRun: TSpeedButton;
    PaxCompiler1: TPaxCompiler;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Run1: TMenuItem;
    Run2: TMenuItem;
    Help1: TMenuItem;
    Help2: TMenuItem;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    LabelRowCol: TLabel;
    LabelState: TLabel;
    PaxPascalLanguage1: TPaxPascalLanguage;
    RadioButtonBasic: TRadioButton;
    RadioButtonPascal: TRadioButton;
    PaxBasicLanguage1: TPaxBasicLanguage;
    CheckBoxBuildWithRuntimePackages: TCheckBox;
    RadioButtonJS: TRadioButton;
    PaxJavaScriptLanguage1: TPaxJavaScriptLanguage;
    PaxInterpreter1: TPaxInterpreter;
    procedure SpeedButtonNewClick(Sender: TObject);
    procedure SpeedButtonOpenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButtonSaveClick(Sender: TObject);
    procedure SpeedButtonRunClick(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Run2Click(Sender: TObject);
    procedure Help2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure PaxCompiler1CompilerProgress(Sender: TPaxCompiler);
    procedure PaxInterpreter1PrintEvent(Sender: TPaxRunner; const Text: string);
    procedure PaxInterpreter1UnhandledException(Sender: TPaxRunner;
      E: Exception; const ModuleName: string; SourceLineNumber: Integer);
  private
    { Private declarations }
    ScriptName: String;
  public
    { Public declarations }
    procedure NewProject;
    procedure OpenProject;
    procedure SaveProject;
    procedure RunProject;
    procedure ShowHelp;
  end;

var
  Form1: TForm1;

implementation

uses Unit2, Unit3;

{$R *.dfm}

const
  PaxBasicFilter = 'Basic file (*.bas)|*.bas|Any file (*.*)|*.*';
  PaxPascalFilter = 'Pascal file (*.pas)|*.pas|Any file (*.*)|*.*';
  PaxJavaScriptFilter = 'JavaScript file (*.js)|*.js|Any file (*.*)|*.*';
  PaxTester = 'PaxTester';

procedure _Writeln;
begin
  Console.Memo1.Text := Console.Memo1.Text + #13#10;
  Console.SetCursor;
end;

procedure _WriteBool(value: Boolean);
begin
  if value then
    Console.Memo1.Text := Console.Memo1.Text + 'true'
  else
    Console.Memo1.Text := Console.Memo1.Text + 'false';
  Console.SetCursor;
end;

procedure _WriteByteBool(value: ByteBool);
begin
  if value then
    Console.Memo1.Text := Console.Memo1.Text + 'true'
  else
    Console.Memo1.Text := Console.Memo1.Text + 'false';
  Console.SetCursor;
end;

procedure _WriteWordBool(value: WordBool);
begin
  if value then
    Console.Memo1.Text := Console.Memo1.Text + 'true'
  else
    Console.Memo1.Text := Console.Memo1.Text + 'false';
  Console.SetCursor;
end;

procedure _WriteLongBool(value: LongBool);
begin
  if value then
    Console.Memo1.Text := Console.Memo1.Text + 'true'
  else
    Console.Memo1.Text := Console.Memo1.Text + 'false';
  Console.SetCursor;
end;

procedure _WriteInt(value: Integer; L: Integer);
var
  S: ShortString;
begin
  if L = 0 then
    Console.Memo1.Text := Console.Memo1.Text + IntToStr(value)
  else
  begin
    Str(value:L, S);
    Console.Memo1.Text := Console.Memo1.Text + String(S);
  end;
  Console.SetCursor;
end;

procedure _WriteShortInt(value: ShortInt; L: Integer);
var
  S: ShortString;
begin
  if L = 0 then
    Console.Memo1.Text := Console.Memo1.Text + IntToStr(value)
  else
  begin
    Str(value:L, S);
    Console.Memo1.Text := Console.Memo1.Text + String(S);
  end;
  Console.SetCursor;
end;

procedure _WriteSmallInt(value: SmallInt; L: Integer);
var
  S: ShortString;
begin
  if L = 0 then
    Console.Memo1.Text := Console.Memo1.Text + IntToStr(value)
  else
  begin
    Str(value:L, S);
    Console.Memo1.Text := Console.Memo1.Text + String(S);
  end;
  Console.SetCursor;
end;

procedure _WriteByte(value: Byte; L: Integer);
var
  S: ShortString;
begin
  if L = 0 then
    Console.Memo1.Text := Console.Memo1.Text + IntToStr(value)
  else
  begin
    Str(value:L, S);
    Console.Memo1.Text := Console.Memo1.Text + String(S);
  end;
  Console.SetCursor;
end;

procedure _WriteWord(value: Word; L: Integer);
var
  S: ShortString;
begin
  if L = 0 then
    Console.Memo1.Text := Console.Memo1.Text + IntToStr(value)
  else
  begin
    Str(value:L, S);
    Console.Memo1.Text := Console.Memo1.Text + String(S);
  end;
  Console.SetCursor;
end;

procedure _WriteCardinal(value: Cardinal; L: Integer);
var
  S: ShortString;
begin
  if L = 0 then
    Console.Memo1.Text := Console.Memo1.Text + IntToStr(value)
  else
  begin
    Str(value:L, S);
    Console.Memo1.Text := Console.Memo1.Text + String(S);
  end;
  Console.SetCursor;
end;

procedure _WriteDouble(value: Double; L1, L2: Integer);
var
  S: ShortString;
begin
  if L1 > 0 then
  begin
    if L2 > 0 then
      Str(value:L1:L2, S)
    else
      Str(value:L1, S);
    Console.Memo1.Text := Console.Memo1.Text + String(S);
  end
  else
    Console.Memo1.Text := Console.Memo1.Text + FloatToStr(value);
  Console.SetCursor;
end;

procedure _WriteSingle(value: Single; L1, L2: Integer);
var
  S: ShortString;
begin
  if L1 > 0 then
  begin
    if L2 > 0 then
      Str(value:L1:L2, S)
    else
      Str(value:L1, S);
    Console.Memo1.Text := Console.Memo1.Text + String(S);
  end
  else
    Console.Memo1.Text := Console.Memo1.Text + FloatToStr(value);
  Console.SetCursor;
end;

procedure _WriteExtended(value: Extended; L1, L2: Integer);
var
  S: ShortString;
begin
  if L1 > 0 then
  begin
    if L2 > 0 then
      Str(value:L1:L2, S)
    else
      Str(value:L1, S);
    Console.Memo1.Text := Console.Memo1.Text + String(S);
  end
  else
    Console.Memo1.Text := Console.Memo1.Text + FloatToStr(value);
  Console.SetCursor;
end;

procedure _WriteAnsiString(const value: AnsiString; L: Integer);
var
  S: ShortString;
begin
  if L = 0 then
    Console.Memo1.Text := Console.Memo1.Text + String(value)
  else
  begin
    S := value;
    while Length(S) < L do
      S := ' ' + S;
    Console.Memo1.Text := Console.Memo1.Text + String(S);
  end;
  Console.SetCursor;
end;

procedure _WriteUnicString(const value: UnicString; L: Integer);
var
  S: String;
begin
  if L = 0 then
    Console.Memo1.Text := Console.Memo1.Text + value
  else
  begin
    S := value;
    while Length(S) < L do
      S := ' ' + S;
    Console.Memo1.Text := Console.Memo1.Text + S;
  end;
  Console.SetCursor;
end;

procedure _WriteShortString(const value: ShortString; L: Integer);
var
  S: String;
begin
  if L = 0 then
    Console.Memo1.Text := Console.Memo1.Text + String(value)
  else
  begin
    S := String(value);
    while Length(S) < L do
      S := ' ' + S;
    Console.Memo1.Text := Console.Memo1.Text + S;
  end;
  Console.SetCursor;
end;

procedure _WriteAnsiChar(value: AnsiChar);
begin
  Console.Memo1.Text := Console.Memo1.Text + String(value);
  Console.SetCursor;
end;

procedure _WriteWideChar(value: WideChar);
begin
  Console.Memo1.Text := Console.Memo1.Text + value;
  Console.SetCursor;
end;

procedure _WriteWideString(const value: WideString; L: Integer);
var
  S: String;
begin
  if L = 0 then
    Console.Memo1.Text := Console.Memo1.Text + value
  else
  begin
    S := value;
    while Length(S) < L do
      S := ' ' + S;
    Console.Memo1.Text := Console.Memo1.Text + S;
  end;
  Console.SetCursor;
end;

procedure _WriteVariant(const value: Variant; L1, L2: Integer);
var
  S: ShortString;
begin
  if L1 > 0 then
  begin
    if L2 > 0 then
      Str(value:L1:L2, S)
    else
      Str(value:L1, S);
    Console.Memo1.Text := Console.Memo1.Text + String(S);
  end
  else
    Console.Memo1.Text := Console.Memo1.Text + VarToStr(value);
  Console.SetCursor;
end;

procedure _WriteCurrency(value: Currency; L1, L2: Integer);
var
  S: ShortString;
begin
  if L1 > 0 then
  begin
    if L2 > 0 then
      Str(value:L1:L2, S)
    else
      Str(value:L1, S);
    Console.Memo1.Text := Console.Memo1.Text + String(S);
  end
  else
    Console.Memo1.Text := Console.Memo1.Text + CurrToStr(value);
  Console.SetCursor;
end;

//-------------- New Project --------------------------------------------------/

procedure TForm1.NewProject;
begin
  Memo1.Clear;
  Caption := PaxTester;
  ScriptName := '';
end;

procedure TForm1.SpeedButtonNewClick(Sender: TObject);
begin
  NewProject;
end;

procedure TForm1.New1Click(Sender: TObject);
begin
  NewProject;
end;

//-------------- Open Project -------------------------------------------------/

procedure TForm1.OpenProject;
var
  S: String;
  P: Integer;
begin
  if RadioButtonBasic.Checked then
  begin
    OpenDialog1.Filter := PaxBasicFilter;
  end
  else if RadioButtonPascal.Checked then
  begin
    OpenDialog1.Filter := PaxPascalFilter;
  end
  else if RadioButtonJS.Checked then
  begin
    OpenDialog1.Filter := PaxJavaScriptFilter;
  end;

  with OpenDialog1 do
  if Execute then
  begin
    S := ExtractFileExt(FileName);

    if CompareText(S, '.pas') = 0 then
      RadioButtonPascal.Checked := true
    else if CompareText(S, '.bas') = 0 then
      RadioButtonBasic.Checked := true
    else if CompareText(S, '.js') = 0 then
      RadioButtonJS.Checked := true
    else
    begin
      ShowMessage('File extension must me ".bas", ".pas" or ".js"');
      Exit;
    end;

    ScriptName := FileName;
    Memo1.Lines.LoadFromFile(ScriptName);
    Memo1.Modified := false;

    Caption := PaxTester + '-' + ScriptName;

    S := ExtractFileDir(FileName);
    SetCurrentDir(S);
  end;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  OpenProject;
end;

procedure TForm1.SpeedButtonOpenClick(Sender: TObject);
begin
  OpenProject;
end;

//-------------- Save Project -------------------------------------------------/

procedure TForm1.SaveProject;
var
  S: String;
  P: Integer;
begin
  if RadioButtonBasic.Checked then
  begin
    SaveDialog1.Filter := PaxBasicFilter;
    S := '.bas';
  end
  else if RadioButtonPascal.Checked then
  begin
    SaveDialog1.Filter := PaxPascalFilter;
    S := '.pas';
  end
  else if RadioButtonJS.Checked then
  begin
    SaveDialog1.Filter := PaxJavaScriptFilter;
    S := '.js';
  end;

  with SaveDialog1 do
  begin
    FileName := ScriptName;
    if Execute then
    begin
      if Pos('.', FileName) = 0 then
        FileName := FileName + S;

      ScriptName := FileName;
      Memo1.Lines.SaveToFile(ScriptName);
      Memo1.Modified := false;

      Caption := PaxTester + '-' + ScriptName;
    end;
  end;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  SaveProject;
end;

procedure TForm1.SpeedButtonSaveClick(Sender: TObject);
begin
  SaveProject;
end;

//-------------- Run Project --------------------------------------------------/

procedure TForm1.RunProject;
var
  I, P: Integer;
  ExeName: String;
begin
  LabelState.Caption := 'Compiling...';

  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxBasicLanguage1);
  PaxCompiler1.RegisterLanguage(PaxPascalLanguage1);
  PaxCompiler1.RegisterLanguage(PaxJavaScriptLanguage1);

  PaxBasicLanguage1.SetCallConv(_ccREGISTER);

  if RadioButtonBasic.Checked then
    PaxCompiler1.AddModule('main', PaxBasicLanguage1.LanguageName)
  else if RadioButtonJS.Checked then
    PaxCompiler1.AddModule('main', PaxJavaScriptLanguage1.LanguageName)
  else if RadioButtonPascal.Checked then
    PaxCompiler1.AddModule('main', PaxPascalLanguage1.LanguageName);

  PaxCompiler1.AddCode('main', Memo1.Text);

  if PaxCompiler1.Compile(PaxInterpreter1, true,
     CheckBoxBuildWithRuntimePackages.Checked) then
  begin
    LabelState.Caption := '';

    PaxInterpreter1.SetAddress(H_Writeln, @_Writeln);
    PaxInterpreter1.SetAddress(H_WriteBool, @_WriteBool);
    PaxInterpreter1.SetAddress(H_WriteByteBool, @_WriteByteBool);
    PaxInterpreter1.SetAddress(H_WriteWordBool, @_WriteWordBool);
    PaxInterpreter1.SetAddress(H_WriteLongBool, @_WriteLongBool);
    PaxInterpreter1.SetAddress(H_WriteInteger, @_WriteInt);
    PaxInterpreter1.SetAddress(H_WriteShortInt, @_WriteShortInt);
    PaxInterpreter1.SetAddress(H_WriteSmallInt, @_WriteSmallInt);
    PaxInterpreter1.SetAddress(H_WriteByte, @_WriteByte);
    PaxInterpreter1.SetAddress(H_WriteWord, @_WriteWord);
    PaxInterpreter1.SetAddress(H_WriteCardinal, @_WriteCardinal);
    PaxInterpreter1.SetAddress(H_WriteDouble, @_WriteDouble);
    PaxInterpreter1.SetAddress(H_WriteSingle, @_WriteSingle);
    PaxInterpreter1.SetAddress(H_WriteExtended, @_WriteExtended);
    PaxInterpreter1.SetAddress(H_WriteCurrency, @_WriteCurrency);
    PaxInterpreter1.SetAddress(H_WriteAnsiString, @_WriteAnsiString);
    PaxInterpreter1.SetAddress(H_WriteUnicString, @_WriteUnicString);
    PaxInterpreter1.SetAddress(H_WriteShortString, @_WriteShortString);
    PaxInterpreter1.SetAddress(H_WriteAnsiChar, @_WriteAnsiChar);
    PaxInterpreter1.SetAddress(H_WriteWideChar, @_WriteWideChar);
    PaxInterpreter1.SetAddress(H_WriteWideString, @_WriteWideString);
    PaxInterpreter1.SetAddress(H_WriteVariant, @_WriteVariant);

    Console.Show;
    PaxInterpreter1.Console := true;

    ExeName := ExtractFileName(ScriptName);
    P := Pos('.', ExeName);
    if PaxInterpreter1.GetProgPtr.ExportList.Count > 0 then
    begin
      if P > 0 then
        ExeName := Copy(ExeName, 1, P) + 'dll'
      else
        ExeName := ExeName + '.dll';
      CreateDllFile(ExeName, PaxInterpreter1, DllName, ScriptDllMainName);
    end
    else
    begin
      if P > 0 then
        ExeName := Copy(ExeName, 1, P) + 'exe'
      else
        ExeName := ExeName + '.exe';
      CreateExeFile(ExeName, PaxInterpreter1, DllName, RunScriptName);
    end;

    PaxInterpreter1.Run;
  end
  else
  begin
    LabelState.Caption := 'There are errors.';
    for I:=0 to PaxCompiler1.ErrorCount - 1 do
      ShowMessage(PaxCompiler1.ErrorMessage[I] + ' at line ' +
                  IntToStr(PaxCompiler1.ErrorLineNumber[I] + 1) + ':' +
                  #13#10 +
                  PaxCompiler1.ErrorLine[I]);
  end;
  LabelState.Caption := '';
end;

procedure TForm1.Run2Click(Sender: TObject);
begin
  RunProject;
end;

procedure TForm1.SpeedButtonRunClick(Sender: TObject);
begin
  RunProject;
end;

//-------------- Help ---------------------------------------------------------/

procedure TForm1.ShowHelp;
var
  L: TStringList;
  S: String;
begin
  S := ExtractFileDir(Application.ExeName) + '\help.txt';
  if not FileExists(S) then
    Exit;
  L := TStringList.Create;
  try
    L.LoadFromFile(S);
    Help.Memo1.Text := L.Text;
    Help.Show;
  finally
    L.Free;
  end;
end;

procedure TForm1.Help2Click(Sender: TObject);
begin
  ShowHelp;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  ShowHelp;
end;

//-------------- Initialize ---------------------------------------------------/

procedure TForm1.FormCreate(Sender: TObject);
var
  S: String;
begin
  S := ExtractFileDir(Application.ExeName);
  SetCurrentDir(S);

  Memo1.Font.Name := 'Courier new';
  Memo1.Font.Size := 12;

  OpenDialog1.InitialDir := S + '\scripts\';
  SaveDialog1.InitialDir := S + '\scripts\';

  ScriptName := '';

  LabelRowCol.Caption := '';
  LabelState.Caption := '';

  RadioButtonBasic.Checked := true;
end;

procedure TForm1.PaxCompiler1CompilerProgress(Sender: TPaxCompiler);
begin
  Application.ProcessMessages;
end;

//-------------- Finalize -----------------------------------------------------/

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Memo1.Modified then
  begin
    if MessageDlg('Script has been changed. Do you want to save it?',
       mtConfirmation, [mbYes, mbNo], 0) = mrYes then
         SaveProject;
  end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.PaxInterpreter1PrintEvent(Sender: TPaxRunner;
  const Text: string);
begin
  Console.Memo1.Text := Console.Memo1.Text + Text;
  Console.SetCursor;
end;

procedure TForm1.PaxInterpreter1UnhandledException(Sender: TPaxRunner;
  E: Exception; const ModuleName: string; SourceLineNumber: Integer);
var
  S: String;
begin
  S := 'Error: ' + E.Message + #13#10 +
       'Module: ' + ModuleName + #13#10 +
       'Line ' + IntToStr(SourceLineNumber) + ':' +
       PaxCompiler1.Modules[ModuleName][SourceLineNumber] + #13#10;
  ShowMessage(S);
end;

end.
